using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace VamTastic
{
    public class GirlsGamerChair : MVRScript
    {
        #region PluginInfo    
        public string pluginAuthor = "Hazmhox"; // edited by VamTastic and added tranform.Postion
        public string pluginName = "Girls Gamer Chair";
        public string pluginVersion = "1";
        public string pluginDate = "14/02" + "/2022";
        public string pluginDescription = @"Used to open and close the doors";
        #endregion

        #region Vars    



        public GameObject player;
        public GameObject KS_Gaming_Chair;

        protected JSONStorableFloat ScrubA;
        protected JSONStorableFloat ScrubB;
		
	    protected JSONStorableFloat yRotation;
//        protected JSONStorableFloat position;		


        private float previousValue1;
        private float previousValue2;		

        private float previousZValue;
        private float currentZValue;

	    public Transform ObjectRoot;
        public Transform chair1;
        public Transform chair2;
		
        private bool editorInitialized = false;
        private int initLoops = 0;
        private int maxInitLoops = 1500; // 3600 for one minute

        #endregion

        public override void Init()
        {
            try
            {
				if (containingAtom.type != "CustomUnityAsset")
				{
	                SuperController.LogError("GirlsGamerChair - Please add this script on a Custom Unity Asset ( script disabled).");
  	                return;
  		        }


                //**************  ScrubA
                ScrubA = new JSONStorableFloat("Chair Rotate", 0f, OnSliderChanged, 0f, 1f);
                RegisterFloat(ScrubA);
                CreateSlider(ScrubA, false);
                          

                //**************  ScrubB
                ScrubB = new JSONStorableFloat("Chair Raise up down", 0f, OnSliderChanged2, 0f, 0.05f);				
                RegisterFloat(ScrubB);
                CreateSlider(ScrubB, false);
								

              // A tiny bit of help to give some info to your fellow creator and/or player
                JSONStorableString helpText = new JSONStorableString("About the Chair Plugin",
                    "<color=#000><size=35><b>About the Chair Plugin</b></size></color>\n\n" +
                    "<color=#333>" +
                    "Credits to Hazmhox.\n\n" +	
                    "I have amended the Script to use up, down and rotate of the chair.\n\n" +					
                    "The Chair Plugin can be triggered using Acidbubbles Timeline to open and close.\n\n" +
                    "</color>" );
               UIDynamic helpTextfield = CreateTextField(helpText, true);
                helpTextfield.height = 1100.0f;

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        // Update is called with each rendered frame by Unity
        void Update()
        {
			// I don't know why the fuck this asset does not get the children properly during the loading process, so I'm checking the singleton
			// In reality, that's even cleaner to do it that way
			if( initLoops < maxInitLoops && editorInitialized == false && !SuperController.singleton.isLoading ) {
                initLoops++;
                InitEditor();
            }
			
			if( initLoops == maxInitLoops ) {
                SuperController.LogError("GamingChair : This CUA could not be initialized properly. Please select a compatible object and reload the script.");
                initLoops++; // To avoid spamming the log with the error
            }
        }

        private bool InitEditor() {
            if( editorInitialized == true ) return true;
        
            ObjectRoot = getObjectRoot( containingAtom.reParentObject, "GamingChair" );
            if( ObjectRoot == null ) {
                return false;
            }
			
            chair1 = getChildRoot(ObjectRoot, "GamingChairSeat");
            chair2 = getChildRoot(ObjectRoot, "GamingChairSeat");			
			 
            // I found my transforms, now the rest
            if( chair1 && chair2 ) {
				editorInitialized = true;
				
				// Everything is initialized, triggering the callbacks to init the door rotation saved in the scene file
				// I'm just quickly fixing the script for VamTastic, I'm not gonna refactor everything, so in reality,
				// the float val param of the callbacks is useless
				OnSliderChanged( 0f );
				OnSliderChanged2( 0f );				
				return true;
            } else {
                SuperController.LogError("GamingChair : your CUA is missing mandatory components.");
                initLoops = maxInitLoops; // We don't have what we need, we consider the initialization failed
                return false;
            }
        
            return false;
        }

		// Recursive function searching for a transform containing the string set in objectNameSearchString
		// It is used the first time for the initialization of the script
		// This script NEEDS to use a string "containing" your original because the cloning of the original asset will add "Clone" behind it.
		private Transform getObjectRoot( Transform parent, string rootName ) {
			foreach( Transform child in parent )
			{
				if( child.name.Contains(rootName) ) {
					return child;
				} else {
					Transform childSearch = getObjectRoot(child,rootName);
					if (childSearch != null) return childSearch;
				}
			}
			
			return null;
		}
		
		private Transform getChildRoot( Transform parent, string searchName ) {
			foreach( Transform child in parent )
			{
				SuperController.LogMessage(">>" + child.name);
				if( child.name == searchName ) {
					
					return child;
				} else {
					Transform childSearch = getChildRoot(child,searchName);
					if (childSearch != null) return childSearch;
				}
			}
			
			return null;
		}

		// chair
        void OnSliderChanged( float rotation )
        {
            
            {
				if( chair1 == null ) return;
				
                var Slider1 = ScrubA.val;
                var a = Slider1 - previousValue1;
				chair1.transform.Rotate(Vector3.back * a * 360);
				previousValue1 = ScrubA.val;
            }

        }

		// chair 
        void OnSliderChanged2( float position )
        {

            {
				if( chair1 == null ) return;
				
                var Slider2 = ScrubB.val;
                var b = Slider2 - previousValue2;

                chair1.transform.position += new Vector3(0f ,b ,0f);
                previousValue2 = ScrubB.val;
            }

        }	

    }
	
}